' Ymodem ROM/RAM Memory upload utility
' Copyright 2010 Raymond Allen
' Free for non-commercial usage as long as this file and notice are not altered

'Tested with Hyperterminal.  
'Vista/Win7:  Search the internet for info on how to copy Hyperterminal from an XP install to Vista/Win7 

CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000

CON
  'These settings upload the ROM Font
  DUMP_Start = $8000  'Memory address of first byte to upload
  DUMP_End = $BFFF    'Memory address of last byte to upload

OBJ  'Objects Section
    'Use the VGA (or TV) text driver for status display
    
  text : "vga_text"    'For NTSC TV Video: Comment out this line...
  'text : "tv_text"    'and un-comment this line  (need to change pin parameter for text.start(pin) command below too).
  

  ymodem : "YmodemData"  'send data file to PC with hyperterminal
  num     : "numbers" 

  
VAR



PUB YModemRomDump|i,t0, nBytes


  text.start(16)    'Start the VGA/TV text driver (uses another cog)
                    'The parameter (16) is the base pin used by demo and proto boards for VGA output
                    'Change (16) to (12) when using "tv_text" driver with demo board as it uses pin#12 for video

  nBytes:=DUMP_End-DUMP_Start+1  

  'send data as binary file
  text.str(string("Sending data as a binary file.",13)) 
  SendYModemBinary(Dump_Start,nBytes,string("DUMP.dat"),31,30,9600)     

  'Done
  text.str(string("All done.",13))  
  
  

     
PRI SendYModemBinary(pData,n,sFilename,rxpin,txpin,baud)
    'Send data as binary file
    text.str(string("Initiating YModem Transfer:  Run Terminal Application Now.",13))
    ymodem.UploadData(pData,n,sFilename,rxpin,txpin,baud)'
    text.str(string("Ymodem file upload complete.",13,13))

DAT



  